// Persistence of Vision Ray Tracer Scene Description File
// File: flames.inc
// Vers: 3.1
// Desc: For the Internet Ray Tracing Competition
// Date: 02/27/99
// Auth: Bob Franke
//

#version 3.1;


#declare FlameInt =
	interior {
		media {
			emission  1.5
	    density {   
	      planar
				color_map{
					[0.00 color rgb<0.00,0.00,0.00> ] 
					[0.5 color rgb<0.00,0.00,0.00> ]
					[0.5 color rgb<0.70,0.02,0.00> ]
					[0.95 color rgb<0.60,0.60,0.00> ]
					[1.0 color rgb<1,1,.8> ] 
				}
			turbulence <.5,.7,.5>*4
			omega 0.25 
      rotate<0,0,-90>
				scale 3
	    }
		}
	}

#declare FlameInt2 =
	interior {
		media {
			emission  1.5
	    density {   
	      planar
				color_map{
					[0.00 color rgb<0.00,0.00,0.00> ] 
					[0.5 color rgb<0.00,0.00,0.00> ] 
					[0.7 color rgb<0.70,0.02,0.00> ]
					[0.95 color rgb<0.60,0.60,0.00> ]
					[1.0 color rgb<1,1,.8> ] 
				}
			turbulence <.5,.7,.5>*4
			omega 0.25 
      rotate<0,0,-95>
				scale 3
	    }
		}
	}
	
#declare FlameMaterial =
  material{
    texture { pigment{rgbf<1,1,1,1>} }
    interior { FlameInt }
	}    

#declare FlameMaterial2 =
	material {
		texture { pigment{rgbf<1,1,1,1>} }
		interior { FlameInt2 }
	}    
	
#declare oneLink=
union{
  object{
    torus { .75/12, .25/12}
    clipped_by{plane{x,0}}
    texture{Rusty_Iron }
  }
  cylinder{<0,0,.75/12>,<1.5/12,0,.75/12>,.25/12}
  cylinder{<0,0,-.75/12>,<1.5/12,0,-.75/12>,.25/12}
  object{
    torus { .75/12, .25/12}
    clipped_by{plane{x,0 inverse}}
    translate<1.5/12,0,0>
    texture{Rusty_Iron}
  }
   texture{Rusty_Iron}
}

#declare oneChain=
#declare xx=0;
union{
  #while (xx < 30)
    object {oneLink rotate<20,0,0> translate<xx/12,0,0>}
    object {oneLink rotate<110,0,0> translate<xx/12 + 2.6875/12,0,0>}
    #declare xx = xx + 2.5625*2;
  #end
} 

	
union{
  cylinder{<0,-3,0>,<0,-4,0>,2.6 open texture{xRusty_Iron}}  
  object{
    sphere{<0,-4,0>,2.6  texture{xRusty_Iron}}
    clipped_by{plane{y,-4}}
  }
  object{oneChain scale .765/0.18   rotate<0,0,77> translate<-2.6,-3,0> rotate<0,15,0>}
  object{oneChain scale .765/0.18   rotate<0,0,77> translate<-2.6,-3,0>  rotate<0,135,0>}
  object{oneChain scale .765/0.18   rotate<0,0,77> translate<-2.6,-3,0> rotate<0,255,0>}
 
 
   union{
    box{<-2,1.25,-.06>/.18,<0,1.30,.06>/.18 } 
    box{<-2,1.0,-.2>/.18,<-2.06,1.60,.2>/.18 } 
    box{<-2,1.0,-.2>/.18,<-2.06,1.60,.2>/.18 translate<0,-8,0>}     
    box{<-2,1.25,-.06>/.18,<0,1.30,.06>/.18 rotate<0,0,45> translate<1.7,2,0>}
  
    object{
      difference{
        cylinder{<0,1.35,-.06>/.18,<0,1.35,.06>/.18, .1/.18 }
        cylinder{<0,1.35,-.09>/.18,<0,1.35,.09>/.18, .04/.18}
      }  
      clipped_by{plane{x,0 inverse}}
    }                               
    texture{Rusty_Iron } 
    rotate<0,90,0>
  }
  light_source{
     <0,1.5,0>  
//    color rgb <1,.5,0>*.7  //test7  
    color rgb <1,.5,0>*.7*1.2 //test8
    #ifndef (test)
      fade_distance 2.5
      fade_power(2)  
     area_light
      <2, 0, 0> <0, 0, 2> // lights spread out across this distance (x * z)
      4, 4                // total number of lights in grid (4x*4z = 16 lights)
      adaptive 1          // 0,1,2,3...
      jitter              // adds random softening of light
    #end  
  }     

  #ifndef (test)  
    sphere { <0,0,0>,5
		  hollow 
		  material { FlameMaterial2 scale .5 } 	  
    }   
  #end  
  scale .18
	translate<-7,9,-3>
	no_shadow
}  
 
union{
  cylinder{<0,-3,0>,<0,-4,0>,2.6 open texture{Rusty_Iron}} 
  object{
    sphere{<0,-4,0>,2.6  texture{Rusty_Iron}}
    clipped_by{plane{y,-4}} 
  }
  
  union{
    box{<-2,1.25,-.06>/.18,<0,1.30,.06>/.18 } 
    box{<-2,1.0,-.2>/.18,<-2.06,1.60,.2>/.18 } 
    box{<-2,1.0,-.2>/.18,<-2.06,1.60,.2>/.18 translate<0,-8,0>}     
    box{<-2,1.25,-.06>/.18,<0,1.30,.06>/.18 rotate<0,0,45> translate<1.7,2,0>}
  
    object{
      difference{
        cylinder{<0,1.35,-.06>/.18,<0,1.35,.06>/.18, .1/.18 }
        cylinder{<0,1.35,-.09>/.18,<0,1.35,.09>/.18, .04/.18}
      }  
      clipped_by{plane{x,0 inverse}}
    }                               
    texture{Rusty_Iron } 
    rotate<0,90,0>
  }
  object{oneChain scale .765/0.18   rotate<0,0,77> translate<-2.6,-3,0> rotate<0,15,0>}
  object{oneChain scale .765/0.18   rotate<0,0,77> translate<-2.6,-3,0>  rotate<0,135,0>}
  object{oneChain scale .765/0.18   rotate<0,0,77> translate<-2.6,-3,0> rotate<0,255,0>}

  light_source{
    <0,1.5,0> 
//    color rgb <1,.5,0>*.9   // test7  
    color rgb <1,.5,0>*.9*1.2    //test8
    #ifndef (test)
      fade_distance 2.5
      fade_power(2)
     area_light
      <2, 0, 0> <0, 0, 2> // lights spread out across this distance (x * z)
      4, 4                // total number of lights in grid (4x*4z = 16 lights)
      adaptive 1          // 0,1,2,3...
      jitter              // adds random softening of light
    #end  
  }   

  #ifndef (test)  
    sphere { <0,0,0>,5 
		  hollow 
		  material { FlameMaterial scale .5 } 	  
		  rotate<0,20,0>
    }
  #end  
	scale .18
	translate<7,9,-3>    
	no_shadow
}   

