// Persistence of Vision Ray Tracer Scene Description File
// File: portal.inc
// Vers: 3.1
// Desc: For the Internet Ray Tracing Competition
// Date: 02/27/99
// Auth: Bob Franke
//

#declare rightColumn=      
union{
  box{<-1.5,0,-1.5>,<1.5,.25,1.5> texture{stone scale 10}} 
  box{<-1.25,9.75,-1.25>,<1.25,10,1.25> texture{stone scale 10}}  
    
  union{  
    cylinder {<0,0,0>, <0,10,0>,1 }
    torus{1.1875, 0.1875  translate<0,0.4375,0>} 
    torus{1.125, 0.125  translate<0,0.625,0>} 
    torus{1.0625, 0.0625  translate<0,1,0>} 
    #ifndef (test)
      #ifndef (noWoman)
        object{woman scale 6.5 translate <0,4.5,-1.07>}
      #end  
    #end  
  }
}  

#declare xrightColumn=      
union{
  box{<-1.5,0,-1.5>,<1.5,.25,1.5> } 
  box{<-1.25,9.75,-1.25>,<1.25,10,1.25>}  
    
  union{  
    cylinder {<0,0,0>, <0,10,0>,1 }
    torus{1.1875, 0.1875  translate<0,0.4375,0>} 
    torus{1.125, 0.125  translate<0,0.625,0>} 
    torus{1.0625, 0.0625  translate<0,1,0>}  
  }
  pigment{Black}
}    
  
#declare holeInTheWall=
difference{
  box{<-7,-1,-.501>, <7,10,30>}  
  object{xrightColumn translate<7,0,0> }
  object{xrightColumn translate<-7,0,0> }
}  
  
#declare ironGate=
union{
  union{
    box{<-6,10.0-1.4,-.06+0.7>, <6,9.25-1.4,.06+0.7> }   
    box{<-6,10.0-1.4,-.12+0.7>, <6,9.875-1.4,.06+0.7> }   
    box{<-6,9.375-1.4,-.12+0.7>, <6,9.25-1.4,.06+0.7> }   
    box{<-1,9.75-1.4,-.12+0.7>, <1,9.5-1.4,.06+0.7> }   
    box{<-6,12.5-1.4,.64>,<6,12.56-1.4,.76>}
    texture{xRusty_Iron scale 1/2.25}
  }  
  #declare xx = -6;
  #while (xx < 6)
    box{<xx-.05,9.25-1.4,-.05+0.7>, <xx+.05,15,.05+0.7> texture{xRusty_Iron scale 1/2.25}} 
    cone{ <xx,9.25-1.4,0.7>,.07   <xx,8.875-1.4,0.7>, .03   
      texture {
        pigment { rgb <0.658824, 0.458824, 0.458824>*.75 }
        finish {
          ambient 0.3
          diffuse 0.7
          reflection 0.015
          brilliance 2
          specular 0.4
          roughness 0.1
        }
        normal {
         bumps -0.5
          scale <0.001, 1, 0.001>
        }      
      }
    }  
    #declare xx = xx+0.5;
  #end
}
  
difference{
  object{ box{<-25,0,-1.5>,<25,24,3>}texture{stone2 scale 10}}        
  object{holeInTheWall} 
  cylinder{<0,6,-10>, <0,6,20>, 7.4 }                             
  height_field {    
    gif "cutout.gif"
    water_level .01 
    translate <-.5, -.5, -.5>
    rotate<0,0,180> 
    scale <21,20,17>
    rotate<-90,0,0> 
    translate<0,7.5,6.5+1.75>
  }   
}   
   
union{
  box{<14,0,0>, <11,20,-300> }  
  box{<-14,0,0>, <-12,20,-300> }  
  box{<-44,16.0,5>, <44,20,-300> }  
  box{<6.22,0,.5>,<20,10.1,3>}
  sphere{<11,8,-1.5>, 1 scale<1,1.5,1>}   
  sphere{<11,3,-1.5>, 1 scale<1,2,1> }   
  sphere{<11,0,-1.5>, 1 scale<1,2,1>}   
  sphere{<11,12,-1.5>,1 }   
  sphere{<11,12,-5>, 1  } 

  sphere{<5.5,14.25,-1.5>,1 scale<1.5,1,1>} 
  sphere{<4.5,16,-1.5>,1 } 
  sphere{<1.5,16.5,-1.5>,1 } 
  sphere{<-2.5,16.5,-1.5>,1 } 
  sphere{<-9,14,-1.5>,1 } 
  sphere{<-4.5,15,-2.5>,1 scale<1.75,1,1>} 

  difference{
    difference{
      cylinder { <0,12.1,0>, <-2,12.1,-50>, 13  scale<1,.65,1> }   
      cylinder { <0,12.1,1>, <-2,12.1,-60>, 12.9  scale<1,.65,1> }   
    }   
    box{<-100,10,10>,<100,-40,-70>} 
  }
  texture{stone2 scale 10} 
}  

union{
  object{
    difference{
      cylinder { <0,6,0>, <0,6,-1>, 8.8 }   
      cylinder { <0,6,1>, <0,6,-3>, 7.4 }  
      cylinder { <0,0,-1>, <0,19,-1>, .07  rotate <0,0,5> translate<0,7,0>}    
      cylinder { <0,0,-1>, <0,19,-1>, .07  rotate <0,0,-5> translate<0,7,0>}  
    
      cylinder { <0,0,-1>, <0,19,-1>, .07  rotate <0,0,-15> translate<0,7,0>}  
      cylinder { <0,0,-1>, <0,19,-1>, .07  rotate <0,0,14> translate<0,7,0>}  
          
      cylinder { <0,0,-1>, <0,19,-1>, .07  rotate <0,0,-24> translate<0,7,0>}  
      cylinder { <0,0,-1>, <0,19,-1>, .07  rotate <0,0,25> translate<0,7,0>}    
    
      cylinder { <0,0,-1>, <0,19,-1>, .07  rotate <0,0,-35> translate<0,7,0>}  
      cylinder { <0,0,-1>, <0,19,-1>, .07  rotate <0,0,34> translate<0,7,0>}  
    
      cylinder { <0,0,-1>, <0,19,-1>, .07  rotate <0,0,-44> translate<0,7,0>}  
      cylinder { <0,0,-1>, <0,19,-1>, .07  rotate <0,0,45> translate<0,7,0>}  
         
      cylinder { <0,0,-1>, <0,19,-1>, .07  rotate <0,0,-55> translate<0,7,0>}  
      cylinder { <0,0,-1>, <0,19,-1>, .07  rotate <0,0,54> translate<0,7,0>}  
         
      cylinder { <0,0,-1>, <0,19,-1>, .07  rotate <0,0,-65> translate<0,7,0>}  
      cylinder { <0,0,-1>, <0,19,-1>, .07  rotate <0,0,64> translate<0,7,0>}  
    }   
    clipped_by{plane{y,10 inverse}}
  } 
  
  object{rightColumn translate<7,0,0> }
  object{rightColumn translate<-7,0,0> }
  
  object{        
    difference{        
      box{<-20,0,0>,<20,20,2>}        
      object{holeInTheWall} 
      cylinder{<0,6,-10>, <0,6,20>,8 }
    }
    clipped_by{plane{z,.5}}
  }     
  texture{stone scale 10}
  texture{ pigment{stoneCracks rotate<0,0,45> scale<.25,.5,.5>*5}}
  texture{ pigment{stoneCracks rotate<30,180,30> scale<.25,.5,.5>*5}}
}

object{ironGate}

